﻿<?php
/*
//=====================================================================
// PLUGIN - TABLE DATA - V0.40
//                                         CONTRIBUTION POUR SPIP 1.9.1
// 19 fév 2007                          Christophe BOUTIN - Opalys.info
//=====================================================================
// L'objet de cette contrib est de visualiser, ajouter et modifier le
// contenu de table extra.
// La contrib 'La gestion de tables SQL supplémentaires' de Déesse A.
// Celle-ci m'a beaucoup plu mais elle m'a laissé sur ma fin...
// Alors je me suis lancé.
// Cette constribution est également inspiré de :
//      - Module édition auteur de la distribution de SPIP
// =====================================================================
// Pour la modification et l'ajout
# Génération automatique d'un formulaire de remplissage d'une table SQL
# à partir de la description fournie par spip_abstract_showtable
# et traitement du formulaire rempli afin d'insérer une nouvelle entrée
# dans la table.
# assimile les petits types à un input et les gros à un textarea
# Traite à part les entrées de type DATETIME, ignore les TIMESTAMP,
// (Commentaires repris de Déesse A.)
// ======================================================================
//
// Espérant que vous apprécirez ce module.
// Bien à vous. - mon mél : perso.contribspip @ cboutin .net -
*/

if (!defined("_ECRIRE_INC_VERSION")) return;

require_once ("base/abstract_sql.php");
include_spip('inc/presentation');

//=========================================================================
//=========================================================================
//
function table_extra_lister($table, $serveur, $field, $key, $boolFntModif,$trisens,$trival)
{
    global $table_prefix, $debut;

    $debut = intval($debut);

    $sqlResult = requete_tabledata($table, $field,$trisens,$trival, $key);
    $nombre_Enregistrements = spip_num_rows($sqlResult);

    $max_par_page = 20;
    $debut = intval($debut);

    if ($debut > $nombre_Enregistrements - $max_par_page)
        $debut = max(0,$nombre_Enregistrements - $max_par_page);

    pipeline('exec_init',array('args'=>array('exec'=>'tabledata'),'data'=>''));

    if ( $nombre_Enregistrements<1)
    {
         echo "<br/>Cette table est actuellement vide:<br/>"
             ,"Elle ne contient aucun enregistrement.<br/><br/>";
    }
    else
    {
        $tabLesEnregistrements = array();
        $i = 0;

        while ($tabUnEnregistrement = spip_fetch_array($sqlResult))
        {
            if ($i>=$debut AND $i<$debut+$max_par_page)
            {
                $tabLesEnregistrements[] = $tabUnEnregistrement ;
            }
            $i++;
         }

         affiche_tabledata($table,$tabLesEnregistrements, $max_par_page, $nombre_Enregistrements, $boolFntModif,$trisens,$trival);
    }
}


//=========================================================================
//=========================================================================
//
function affiche_tabledata($table,$tabLesEnregistrements, $max_par_page, $nombre_Enregistrements, $boolFntModif,$trisens,$trival)
{
    global $debut, $options, $spip_lang_right, $visiteurs, $connect_id_auteur, $connect_statut,   $connect_toutes_rubriques;

    //début affichage tableau
    echo "<DIV id='tabledate_tablist'  style='width:498px;overflow:auto'>\n";
    echo "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 WIDTH='100%' class='arial2' style='border: 1px solid #aaaaaa;'>\n";
    echo "<tr bgcolor='#DBE1C5'>";

    // Affichage dynamique des colonnes
    $tabPremiers = $tabLesEnregistrements[0];


    foreach ($tabPremiers as $txtTitre=>$valeur)
    {
        echo "\t<td>";
        echo "\t\t<b>",$txtTitre,"</b>";
        if ($trival==$txtTitre)
        {
            if ($trisens=="A")
            {  // si A on demande D
                echo "<a href='"
                     , tabledata_generer_url_ecrire('tabledata',
                         "debut=".$j."&table=".$table."&trisens=D&trival=".$txtTitre)
                     , "'>"
                     ,"<IMG src='",_DIR_PLUGIN_TABLEDATA,"/img_pack/tri_asc.png' title='Trier sur ce champ ordre décroissant'>"
                     ,"</a>";
            }
            else if ($trisens=="D")
            {   // si D on demande aucun
                echo "<a href='"
                     , tabledata_generer_url_ecrire('tabledata',
                         "debut=".$j."&table=".$table)
                     , "'>"
                     ,"<IMG src='",_DIR_PLUGIN_TABLEDATA,"/img_pack/tri_desc.png' title='Arrêter le tri  sur ce champ'>"
                     ,"</a>";
            }
            else
            {   // si pas (A ouD) alors y en a pas on demande A
                echo "<a href='"
                     , tabledata_generer_url_ecrire('tabledata',
                         "debut=".$j."&table=".$table."&trisens=A&trival=".$txtTitre)
                     , "'>"
                     ,"<IMG src='",_DIR_PLUGIN_TABLEDATA,"/img_pack/tri_off.png' title='Trier sur ce champ ordre croissant'>"
                     ,"</a>";
            }
        }
        else
        {   // Aucun tri n'est déjà proposé
            echo "<a href='"
                 , tabledata_generer_url_ecrire('tabledata',
                     "debut=".$j."&table=".$table."&trisens=A&trival=".$txtTitre)
                 , "'>"
                 ,"<IMG src='",_DIR_PLUGIN_TABLEDATA,"/img_pack/tri_off.png' title='Trier sur ce champ ordre croissant'>"
                 ,"</a>";
        }
        echo "\t</td>\n";     //"../"
    }
    echo "</tr>\n";

    if ($nombre_Enregistrements > $max_par_page)
    {
        echo "<tr bgcolor='white'>"
               ,"<td class='arial1' colspan='",count($tabLesEnregistrements[0]),"'>";

        for ($j=0; $j < $nombre_Enregistrements; $j+=$max_par_page)
        {
            if ($j > 0) echo " | ";

            if ($j == $debut)
                echo "<b>$j</b>";
            else if ($j > 0)
              echo "<a href='"
                    , tabledata_generer_url_ecrire('tabledata',"debut=".$j."&table=".$table
                                          ."&trisens=".$trisens."&trival=".$trival)
                    , "'>$j</a>";
            else
              echo "<a href='"
                    , tabledata_generer_url_ecrire('tabledata',"table=".$table
                                          ."&trisens=".$trisens."&trival=".$trival)
                    , "'>0</a>";

            if ($debut > $j  AND $debut < $j+$max_par_page)
            {
                echo " | <b>$debut</b>";
            }

        }
        echo "</td></tr>\n"; // fin de ligne
        echo "<tr height='5'></tr>"; // ligne espacement
    }

    afficher_n_enregistrements( $tabLesEnregistrements , $table , $boolFntModif);

    echo "</table>\n"; // FIN DE TABLEAU
    echo "</div>\n"; // id='tabledate_tablist'

    echo "<a name='bas'>";
    echo "<table width='100%' border='0'>";

    $debut_suivant = $debut + $max_par_page;
    if ($visiteurs) $visiteurs = "\n<input type='hidden' name='visiteurs' value='oui' />";
    if ($debut_suivant < $nombre_Enregistrements OR $debut > 0)
    {
        echo "<tr height='10'></tr>";
        echo "<tr bgcolor='white'><td align='left'>";
        if ($debut > 0)
        {
            $debut_prec = max($debut - $max_par_page, 0);
            echo tabledata_generer_url_post_ecrire("tabledata"
                                 ,"&debut=".$debut_prec."&table=".$table),
              "\n<input type='submit' value='&lt;&lt;&lt;' class='fondo' />",
              $visiteurs,
              "\n</form>";
        }

        echo "</td><td style='text-align: $spip_lang_right'>";

        if ($debut_suivant < $nombre_Enregistrements)
        {
            echo tabledata_generer_url_post_ecrire("tabledata","tri=".$tri."&debut=".$debut_suivant."&table=".$table),
              "\n<input type='submit' value='&gt;&gt;&gt;' class='fondo' />",
              $visiteurs,
              "\n</form>";
        }
        echo "</td></tr>\n";
    }

    echo "</table>\n"; // FIN DE TABLEAU

} //function affiche_tabledata



//=========================================================================
//=========================================================================
//
function requete_tabledata($table , $field,$trisens,$trival, $key, $idWhere = false)
{
    global $connect_statut, $spip_lang, $connect_id_auteur;

    if ( isset($key['PRIMARY KEY']))
    {
// JFM - Debut (Modification)
         $txtQuery = "SELECT `".$key['PRIMARY KEY']."`";
// JFM - Fin
         $boolBesoinSeparateur = true;
    }
    else
    {
         $txtQuery = "SELECT ";
         $boolBesoinSeparateur = false ;
    }


    foreach ($field as $cle=>$txtChamp)
    {
// JFM - Debut (Modification)
        if ($key['PRIMARY KEY']!=$cle) $txtQuery .= ($boolBesoinSeparateur?", ":"")."`".$cle."`";
// JFM - Fin
        $boolBesoinSeparateur = true;
    } // foreach ($field as $cle=>$txtChamp)

    $txtQuery .= " FROM ". $table ;

    if ($idWhere!=false)
    {
// JFM - Debut (Modification)
        $txtQuery .= " WHERE `".$key['PRIMARY KEY']."`='".$idWhere."';" ; // Limitation1
// JFM - Fin
    } // if ($idWhere)
    else
    {

        if ( isset($trival) && $trival!="")
        {
// JFM - Debut (Modification)
            $txtQuery .= " ORDER by `".$trival."`"
                        .($trisens=="D"?" DESC":"").";" ;
// JFM - Fin
        }
        else if ( isset($key['PRIMARY KEY']))
        {
// JFM - Debut (Modification)
            $txtQuery .= " ORDER by `".$key['PRIMARY KEY']."`;" ; // Limitation1
// JFM - Fin
        } //if ( isset($key['PRIMARY KEY']))
    } // if ($idWhere)

    // Dans la suite : Le nombre de champs à afficher est dynamique.
    // Et : l'Identifiant (Id Ligne) doit être le premier champ retourné par SELECT

    $rows = spip_query($txtQuery);

    return $rows;
} //function requete_fotoformats




//=========================================================================
//=========================================================================
// Le nombre de champs à afficher est dynamique.
// Par contre l'Identifiant (Id Ligne) doit être le premier champ à gauche
function afficher_n_enregistrements($tabLesEnregistrements, $table, $boolFntModif)
{
    global $connect_statut, $options, $messagerie;

    foreach ($tabLesEnregistrements as $intNumLigne=>$tabUnEnregistrement)
    {

        echo "\t<tr style='background-color: #eeeeee;'>\n";
        $compteur = 1 ; // limitation 1
        foreach ($tabUnEnregistrement as $txtChamp=>$txtValeur)
        {
            if ( $compteur==1 ) $idLigne= $txtValeur; // limitation 1 : id = 1° champ

            echo "\t\t<td class='arial1' style='border-top: 1px solid #cccccc;'>\n";
            if ($boolFntModif)
            {
                echo "\t\t\t<a href='"
                       ,tabledata_generer_url_ecrire('tabledata'
                                   ,"action=edit&id_ligne=".$idLigne."&table=".$table)  // limitation 1
                ,"'>\n";
                echo "\t\t\t\t",$txtValeur,"\n" ;
                echo "\t\t\t</a>\n";
            }
            else
            {
                echo "\t\t\t\t",$txtValeur,"\n" ;
            }
            echo "\t\t</td>\n";

            ++$compteur;
        } // foreach ($tabUnEnregistrement as $txtChamp=>$txtValeur)

        echo "\t</tr>\n";
    } ///foreach ($tabLesEnregistrements as $intNumLigne=>$tabUnEnregistrement)

} // function afficher_n_enregistrements


//=========================================================================
//=========================================================================
//
function table_extra_getmodif($table, $serveur, $field, $key , $idLigne)
{

    $sqlResult = requete_tabledata($table , $field,"","", $key, $idLigne);
    $nombre_Enregistrements = spip_num_rows($sqlResult);

    if ($nombre_Enregistrements>0)
    {
        $total = '';
        $hiddens = '';
        $tabUnEnregistrement = spip_fetch_array($sqlResult);

        foreach ($field as $k => $v)
        {
          if (array_search($k, $key) == "PRIMARY KEY")
          {
              $debut = "Modifier l'enregistrement ayant comme clé primaire :<br/><i><b>"
                        .$k."='".$tabUnEnregistrement[$k]."'</b></i><br/>";
          }
          else
          {
              ereg("^ *([A-Za-z]+) *(\(([^)]+)\))?(.*DEFAULT *'(.*)')?", $v, $m);
              $type = $m[1];
              $s = ($m[5] ? " value='$m[5]' " : '');
              $t = $m[3];
              if ($m[2])
              {
                  if (is_numeric($t))
                  {
                    if ($t <= 32)
                    {
                        $s .= " sizemax='$t' size='" . ($t * 2) . "'";
                    }
                    else
                    {
                        $type = 'BLOB';
                    }
                  }
                  else
                  {
                    ereg("^ *'?(.*[^'])'? *$", $t, $m2); $t = $m2[1];
                  }
              }

              switch (strtoupper($type))
              {
// JFM - Debut (Ajout/Modification)
                case TINYINT:
									if ($t==1)
                  {
							      $checked = "";
										if ($tabUnEnregistrement[$k] == 1)
										{
										  $checked = " checked";
										}
										$s = "<td>"
	                       ."<input type='checkbox' name='".$k."'"
	                       ." value='1'".$checked."/>"
	                       ."</td>\n";
										break;
									}
                case BIGINT:
                case CHAR:
                case INT:
                case INTEGER:
                case TEXT:
                case TINYBLOB:
                case TINYINT:
                case TINYTEXT:
                case VARCHAR:
                case YEAR:
                  $s = "<td>"
                       ."<input type='text'".$s." name='".$k."'"
                       ." value='".htmlentities($tabUnEnregistrement[$k], ENT_QUOTES)."'/>"
                       ."</td>\n";
                  break;
                case ENUM:
                case SET:
                  $s = "<td><select name='$k'>\n";
                  foreach (split("'? *, *'?",$t) as $v)
                  {
                     # if (!$v) $v = "''";
                     if ($tabUnEnregistrement[$k]==$v)
                     {
                        $s .= "<option selected>$v</option>\n";
                     }
                     else
                     {
                        $s .= "<option>$v</option>\n";
                     }
                  } //foreach (split("'? *, *'?",$t) as $v)
                  $s .= "</select></td>\n";
                  break;
// JFM - Fin
                case DATETIME:
                  $s = '';
                  $hiddens .= "<input type='hidden' name='$k' value='".$tabUnEnregistrement[$k]."'/>\n";
                  break;
                case TIMESTAMP:
                  $s = '';
                  break;
                case LONGBLOB:
// JFM - Debut (Modification)
                  $s = "<td><textarea name='$k' cols='64' rows='20'>".htmlentities($tabUnEnregistrement[$k])."</textarea></td>\n";
// JFM - Fin
                  break;
                default:
                  $t = floor($t / 64)+1;
// JFM - Debut (Modification)
                  $s = "<td><textarea name='$k' cols='64' rows='$t'>".htmlentities($tabUnEnregistrement[$k])."</textarea></td>\n";
// JFM - Fin
                  break;
              } //switch (strtoupper($type))
              if ($s)
                $total .= "<tr><td>$k</td>\n$s</tr>\n";
          }
        }
        return tabledata_generer_url_post_ecrire('tabledata'
                               , "table=".$table."&serveur=".$serveur
                                   ."&mode=".$mode."&action=maj&id_ligne=".$idLigne)
                                 ."<table>\n".$debut.$total
                                 ."</table>".$hiddens."<input type='submit'/></form>";
    } // if ($nombre_Enregistrements>0)

} // function table_extra_getmodif


//=========================================================================
//=========================================================================
//
function table_extra_get($table, $serveur, $field, $key)
{
  $total = '';
  $hiddens = '';
  foreach ($field as $k => $v)
  {
      if (array_search($k, $key) == "PRIMARY KEY")
          $debut = "<i>'".$k."'</i> est la clé primaire de la table <i>'".$table."'</i><br/>";
      else
      {
          ereg("^ *([A-Za-z]+) *(\(([^)]+)\))?(.*default *'(.*)')?", $v, $m);
          // Si majuscule ne marche pas (test avec mysql 3.23)
          // ereg("^ *([A-Za-z]+) *(\(([^)]+)\))?(.*default *'(.*)')?", $v, $m);

          $type = $m[1];
          $s = ($m[5] ? " value='$m[5]' " : '');
          $t = $m[3];
          if ($m[2])
          {
              if (is_numeric($t))
              {
                if ($t <= 32)
                    $s .= " sizemax='$t' size='" . ($t * 2) . "'";
                else
                    $type = 'BLOB';
              }
              else
              {
                ereg("^ *'?(.*[^'])'? *$", $t, $m2); $t = $m2[1];
              }
          }
          switch (strtoupper($type))
          {
// JFM - Debut (Ajout/Modification)
            case TINYINT:
							if ($t==1)
              {
					      $checked = "";
								if ($tabUnEnregistrement[$k] == 1)
								{
								  $checked = " checked";
								}
								$s = "<td><input type='checkbox' name='".$k."' value='1'".$checked."/></td>\n";
								break;
							}
            case BIGINT:
            case CHAR:
            case INT:
            case INTEGER:
            case TEXT:
            case TINYTEXT:
            case TINYINT:
            case TINYBLOB:
            case VARCHAR:
              $s = "<td><input type='text'$s name='$k'/></td>\n";
              break;
             case ENUM:
             case SET:
// JFM - Fin
              $s = "<td><select name='$k'>\n";
              foreach (split("'? *, *'?",$t) as $v)
              {
                    #if (!$v) $v = "''";
                    $s .= "<option>$v</option>\n";
              }
              $s .= "</select></td>\n";
              break;
            case DATETIME:
              $s = '';
              $hiddens .= "<input type='hidden' name='$k' value='NOW()'/>\n";
              break;
            case TIMESTAMP:
              $s = '';
              break;
            case LONGBLOB:
// JFM - Debut (Ajout/Modification)
              $s = "<td><textarea name='$k' cols='64' rows='20'>".htmlentities($m[5])."</textarea></td>\n";
// JFM - Fin
               break;
            default:
              $t = floor($t / 64)+1;
// JFM - Debut (Ajout/Modification)
              $s = "<td><textarea name='$k' cols='64' rows='$t'>".htmlentities($m[5])."</textarea></td>\n";
// JFM - Fin
               break;
          }
          if ($s)
            $total .= "<tr><td>$k</td>\n$s</tr>\n";
      }
  }
  return tabledata_generer_url_post_ecrire('tabledata'
                           , "table=".$table."&serveur=".$serveur."&mode=".$mode)
                             ."<table>\n".$debut.$total
                             ."</table>$hiddens<input type='submit'/></form>";

}


//===========================================================
function table_extra_post($table, $serveur)
{
  unset($_POST['table']);
  unset($_POST['serveur']);
  unset($_POST['mode']);
  unset($_POST['exec']);
  $n = array();
  $i = array();

  foreach ($_POST as $k => $v)
  {
        if ($v && ($v != 'NOW()')) $v = "'" . addslashes($v) . "'";
        if ($v) { $n[] = $k; $i[] = $v;}
  }
  $r = spip_abstract_insert($table,
                 "(" . join(', ', $n) . ")",
                 "(" . join(', ', $i) . ")",
                 $serveur);

  return "Insertion dans la table $table " .
    (!$r ? '' : ("sous le numero: $r"));
}


//===========================================================
function table_extra_modif_post($table , $field, $key, $serveur, $idWhere)
{
  unset($_POST['table']);
  unset($_POST['serveur']);
  unset($_POST['mode']);
  unset($_POST['exec']);
  $n = array();
  $i = array();

    $txtQuery = "UPDATE ". $table." SET ";

    $txtSeparation="";
    foreach ( $field as $cle=>$txtChamp )
    {
        if ( $key['PRIMARY KEY']!=$cle )
        {
            if ( isset($_POST[$cle]) )
                $txtQuery .= $txtSeparation.$cle."= '".addslashes($_POST[$cle])."'" ;
            $txtSeparation=", ";
        }
    } // foreach $field

    $txtQuery .= " WHERE ".$key['PRIMARY KEY']."='".$idWhere."';" ; // Limitation1

    $retourQuery = spip_query($txtQuery);

    return "" .
        (!$retourQuery ?
           '<br/><b>Erreur dans la requete à la base...</b><br/>'
           : ("<br/>Modification de la ligne : ".$idWhere
               .", dans la table ".$table."<br/>"));
}


//===========================================================
//===========================================================
//
function Afficher_Cadre_InfoInserer($table, $serveur)
{
    echo "<br>";
    gros_titre("Insertion : <I>'".$table."'</I>");
    debut_cadre_relief("../"._DIR_PLUGIN_TABLEDATA."/img_pack/tabledata-add.gif");
    echo "<br/>".table_extra_post($table, $serveur)."<br/><br/>";
    fin_cadre_relief();
}


//===========================================================
//===========================================================
//
function Afficher_Cadre_InfoModifier($table, $serveur, $field, $key,$idLigne)
{
    echo "<br>";
    gros_titre("Modification : <I>'".$table."'</I>");
    debut_cadre_relief("../"._DIR_PLUGIN_TABLEDATA."/img_pack/tabledata.gif");
    echo "<br/>".table_extra_modif_post($table, $serveur, $field, $key,$idLigne)."<br/>";
    fin_cadre_relief();
}


//===========================================================
//===========================================================
//
function Afficher_Cadre_Supprimer($table, $serveur, $field, $key)
{
    echo "<br>";
    gros_titre("Suppression dans : <I>'".$table."'</I>");
    debut_cadre_relief("../"._DIR_PLUGIN_TABLEDATA."/img_pack/tabledata.gif");
    echo "<br/>Le code de suppression n'est pas encore créé...<br/>";
    fin_cadre_relief();
}

//===========================================================
//===========================================================
//
function Afficher_Cadre_Lister($table, $serveur, $field, $key, $boolFntModif,$trisens,$trival)
{
    echo "<br>";
    gros_titre('Info sur la table : <I>'.$table.'</I>');
    echo "<p>";
    debut_cadre_relief("../"._DIR_PLUGIN_TABLEDATA."/img_pack/tabledata.gif");
    echo table_extra_lister($table, $serveur, $field, $key, $boolFntModif,$trisens,$trival);
    fin_cadre_relief();
}


//===========================================================
//===========================================================
//
function Afficher_Cadre_Ajouter($table, $serveur, $field, $key)
{
    gros_titre('<br/>Ajouter un nouvel enregistrement :');
    echo "<p>";
    debut_cadre_relief("../"._DIR_PLUGIN_TABLEDATA."/img_pack/tabledata-add.gif");
    echo table_extra_get($table, $serveur, $field, $key);
    fin_cadre_relief();
}

//===========================================================
//===========================================================
//
function Afficher_Cadre_Modifier($table, $serveur, $field, $key , $idLigne)
{
    gros_titre('<br/>Modifier un enregistrement :');
    echo "<p>";
    debut_cadre_relief("../"._DIR_PLUGIN_TABLEDATA."/img_pack/tabledata.gif");
    echo table_extra_getmodif($table, $serveur, $field, $key , $idLigne);
    fin_cadre_relief();
    echo "<center><a href='"
          , tabledata_generer_url_ecrire('tabledata',"table=".$table)
          , "'>- Retour à la liste -</a></center>";
}


//===========================================================
//===========================================================
//
function afficher_liste_des_tables ($serveur,$boolSPIP=false)
{
    global $connect_statut, $spip_lang, $connect_id_auteur;
    global $table_prefix;

    $txtHTML = "Choisir une table parmis la liste ci-dessous:"
                ."<table>\n";

    $txtQuery = "SHOW TABLES ;";

    $sqlResultTables = spip_query($txtQuery);

    $intLongueur = strlen($table_prefix);
    $intNb = 0;

    while ($tabNomTable = mysql_fetch_row($sqlResultTables) ) // TODO1
    {
        $txtNomTable = $tabNomTable[0];
        if ($boolSPIP || $table_prefix!=substr($txtNomTable,0,$intLongueur))
        {
            ++$intNb ;
            $txtHTML .= "\t<tr><td>".$intNb
                          .". <a href='".tabledata_generer_url_ecrire('tabledata',"table="
                          .$txtNomTable)."'>"
                          .$txtNomTable."</a></td></tr>\n";
        } //if ($boolSPIP || $table_prefix!=...
    } //while ($tabNomTable =...
    $txtHTML .= "</table>\n";

    if ($intNb=0) $txtHTML = "Aucune table extra ne semble disponible.";

    return $txtHTML;
} // function afficher_liste_des_tables


function  tabledata_generer_url_ecrire ($fonction,$txt_var_get, $boolVoirSPIP=false)
{
    global $boolDebrid;

    if ($boolVoirSPIP != "masquer")
    {
        if ($boolVoirSPIP=="voir" || $boolDebrid)
            $txt_var_get= $txt_var_get."&debrid=aGnFJwE" ;
    }
    return generer_url_ecrire ($fonction,$txt_var_get);
}

function  tabledata_generer_url_post_ecrire ($fonction,$txt_var_post, $boolVoirSPIP=false)
{
    global $boolDebrid;

    if ($boolVoirSPIP != "masquer")
    {
        if ($boolVoirSPIP=="voir" || $boolDebrid)
            $txt_var_post= $txt_var_post."&debrid=aGnFJwE" ;
    }
    //    if ($boolVoirSPIP || $boolDebrid) $txt_var_post= $txt_var_post."&debrid=aGnFJwE" ;
    return generer_url_post_ecrire ($fonction,$txt_var_post);
}



//===========================================================
//===========================================================
//
//function exec_tabledata_dist()
function exec_tabledata()
{
    global $debut, $options, $spip_lang_right, $visiteurs, $connect_id_auteur
         , $connect_statut,   $connect_toutes_rubriques;
    global $table_prefix;
    global $boolDebrid;

    $table = _request('table');
    $serveur = _request('serveur');
    $mode = _request('mode');
    $idLigne = _request('id_ligne');
    $trisens = _request('trisens');
    $trival = _request('trival');
    $get_Debrid = _request('debrid');

    if ($get_Debrid=="aGnFJwE") $boolDebrid=true;

    pipeline('exec_init',array('args'=>array('exec'=>'tabledata'),'data'=>''));

    debut_page('tabledata', 'lister', 'rubriques');
    debut_gauche();
    debut_boite_info();
    // Par la suite, c'est ici qu'il faudrait inscrire les messages pour l'utilisateur...
    // mais il faut remanier tout le code.
    echo "<p class='arial1'>"
           ,"<b>Information</b>"
           ,"<hr/>Lister une table de données<hr/>"
           ,"table sélectionnée:<br/><center><b>"
           .($table==""?"Aucune n'est sélectionnée":$table)
           ."</b></center>";
    fin_boite_info();

    debut_raccourcis();
    // Par la suite, c'est ici qu'il faudrait mettre l'aide des commandes.
    echo "<p class='arial1'>"
           ,"<b>LISTER</b> : Affichage par groupe de 20 enregistrements."
           ," (Triés sur la clef primaire si elle existe)"
           ,"<br/><br/><u>Les Qq Commandes</u><br/>"
           ,"<br/><b>TRIER</b> : Cliquer sur l'icone ^v dans l'entête du champ"
           ," (bascule à chaque clic Ascendant, Decsendant, Aucun)<br/>"
           ,"<br/><b>AJOUTER</b> : voir formulaire du bas de page<br/>"
           ,"<br/><b>SUPPRIMER</b> : Non diponible<br/>"
           ,"<br/><b>MODIFIER</b> : Cliquer sur l'enregistement<br/>";
    if ($connect_statut == '0minirezo')
    {
        echo "<hr/>";
        if ($boolDebrid)
        {
            echo "<br/><a href='"
                 , tabledata_generer_url_ecrire('tabledata',"table","masquer")
                 , "'>SPIP</a>"
                 ," : Masquer les tables SPIP.<br/>";
        }
        else
        {
            echo "<br/><a href='"
                 , tabledata_generer_url_ecrire('tabledata',"table","voir")
                 , "'>SPIP</a>"
                 ," : Voir les tables SPIP.<br/>";
        }
        echo "<br/>";
    } // if ($connect_statut == '0minirezo')
    fin_raccourcis();

    echo pipeline('affiche_gauche'
                   ,array('args'=>array('exec'=>'tabledata'),'data'=>''));
    creer_colonne_droite();
    echo pipeline('affiche_droite'
                   ,array('args'=>array('exec'=>'tabledata'),'data'=>''));
    debut_droite();
    //  debut_cadre_formulaire();


    // ======== Teste si le nom de la table est mentionné
    if ($table=="")
    {
        if ($boolDebrid)
        {
                gros_titre('<br/>ATTENTION :');
                echo "La modification du contenu des tables de SPIP peut engendrer"
                      ," des dysfontionnements graves.<br/>"
                      ,"Faite une sauvegarde de la base, elle "
                      ,"permettra une réparation en cas de problème.<br/>";
        }
        gros_titre('<br/>Choisir une table :');
        debut_cadre_relief("../"._DIR_PLUGIN_TABLEDATA."/img_pack/tabledata.gif");
        echo "Le nom de la table est manquant.<br/><br/>";
        echo afficher_liste_des_tables ($serveur,$boolDebrid);
        fin_cadre_relief();
        Tabledata_fin_page();
        exit;
    } // if ($table=="")

    // ======== Recherche si la table existe ? ===========
    if (!preg_match('/^[\w_]+$/', $table))
    {
        debut_cadre_relief("../"._DIR_PLUGIN_TABLEDATA."/img_pack/tabledata.gif");
        echo "'".$table."': nom incorrect";
        fin_cadre_relief();
       echo "<center><a href='"
                      , tabledata_generer_url_ecrire('tabledata',"table")
                      , "'>- Retour à la liste des tables -</a></center>";
        Tabledata_fin_page();
        exit;
    } // if (!preg_match('/^[\w_]+$/', $table))

    if (strpos($table,$table_prefix,0)===0) // cas d'une table SPIP
    {
        if ($boolDebrid)
        {   // cas table SPIP autorisée
            gros_titre('<br/>ATTENTION :');
            echo "Vous intervenez sur une table interne de SPIP."
                  ," Agissez avec précautions.<br/>";
        }
        else
        {   // protection active et table SPIP !!
            debut_cadre_relief("../"._DIR_PLUGIN_TABLEDATA."/img_pack/tabledata.gif");
            echo "<br/>Le paramètre <i>table</i> (valeur: '"
              ,$table
              ,"') indique une table protégée de SPIP.<br/><br/>";
            fin_cadre_relief();
            echo "<center><a href='"
                          , tabledata_generer_url_ecrire('tabledata',"table")
                          , "'>- Retour à la liste des tables -</a></center>";
            Tabledata_fin_page();
            exit;
        }
    } // if (!$description)

    $description = spip_abstract_showtable($table, $serveur);

    $table2 = "";
    if ($boolDebrid && !$description)
    {
        // recherche avec l'extention définie pour SPIP $table_prefix
        $table2 = $table_prefix.'_'. $table;
        $description = spip_abstract_showtable($table2, $serveur);
    } // if (!$description)

    spip_log("description ".$description);
    $field = $description['field'];
    $key = $description['key'];
    $intClefNbChamp= (count($key)>0?count(split (",",$key["PRIMARY KEY"])):0);

    //    if (! ($field && $key))
    if (! ($field))
    {
        // la table n'existe pas !!
        debut_cadre_relief("../"._DIR_PLUGIN_TABLEDATA."/img_pack/tabledata.gif");
        echo "Le paramètre <i>table</i> (valeur: '"
          ,$table
          ,"') n'indique pas une table exploitable par le serveur SQL ",$serveur;
        fin_cadre_relief();
        echo "<center><a href='"
                      , tabledata_generer_url_ecrire('tabledata',"table")
                      , "'>- Retour à la liste des tables -</a></center>";
    } // if (! ($field && $key))
    else
    {
       // la table existe.
        if ($table2) $table = $table2;

        switch ($intClefNbChamp)
        {
            case 0 :
            // Il n'y a pas de clef primaire => désactiver modification...
                // désactiver modif
                $boolFntAjout = true;
                $boolFntModif = false;
                $txtMsgInfoTable= "<br/>Votre table ne contient pas de clef primaire. "
                                 ."<I>(La modification des enregistrements est désactivée)"
                                 ."</i><br/>";
            break;

            case 1 :
            // il y a une clé primaire sur champ unique =OK
                if (strpos($field[$key["PRIMARY KEY"]],"auto_increment",0)===False)
                {
                    // Si pas d'autoincrement : désactiver ajout
                    $boolFntAjout = false;
                    $txtMsgInfoTable= "<br/>La clef primaire de la table n'est pas"
                                       ." autoincrémentée. "
                             ."<I>(L'insertion d'un nouvel enregistrement est désactivée)"
                             ."</i><br/>";
                } //if (strpos($field[$key["PRIMARY KEY"]]
                else
                {
                    // Si autoincrement : Activer ajout
                    $boolFntAjout = true;
                    $txtMsgInfoTable= "";
                } //if (strpos($field[$key["PRIMARY KEY"]]
                $boolFntModif = true;

            break;

            default :
                // il y a une clé primaire sur champs multiple = pas géré pour le moment...
                // désactiver modif et ajout
                $boolFntAjout = false;
                $boolFntModif = false;
                $txtMsgInfoTable= "<br/>La clef primaire contient plusieurs champs. "
                             ."<I>(L'insertion et la modification sont désactivées)</i><br/>";
        } //switch ($intClefNbChamp)

        // CHOIX DE L'ACTION A REALISER => de l'affichage

        if ($_SERVER['REQUEST_METHOD'] == 'POST')
        {
            // la page est arrivée en POST
            switch ($_POST['action'])
            {
            case "maj" :
                // la page est arrivée en POST avec action=maj
                //  ==> Demande Enregistrement des valeurs.
                Afficher_Cadre_InfoModifier($table , $field, $key, $serveur, $idLigne) ;
                echo "<center><a href='"
                      , tabledata_generer_url_ecrire('tabledata',"table")
                      , "'>- Retour à la liste des tables -</a></center>";
                echo $txtMsgInfoTable;
                Afficher_Cadre_Lister($table, $serveur, $field, $key, $boolFntModif,$trisens,$trival);
                if ($boolFntAjout) Afficher_Cadre_Ajouter($table, $serveur, $field, $key);
                echo "<center><a href='"
                      , tabledata_generer_url_ecrire('tabledata',"table")
                      , "'>- Retour à la liste des tables -</a></center>";
                break;
            default:
                // la page est arrivée en POST sans action ou autre
                //  ==> Demande Insertion des valeurs.
                Afficher_Cadre_InfoInserer($table, $serveur);
                echo "<center><a href='"
                      , tabledata_generer_url_ecrire('tabledata',"table")
                      , "'>- Retour à la liste des tables -</a></center>";

                echo $txtMsgInfoTable;
                Afficher_Cadre_Lister($table, $serveur, $field, $key, $boolFntModif,$trisens,$trival);
                if ($boolFntAjout) Afficher_Cadre_Ajouter($table, $serveur, $field, $key);
                echo "<center><a href='"
                      , tabledata_generer_url_ecrire('tabledata',"table")
                      , "'>- Retour à la liste des tables -</a></center>";
                break;
            } // switch ($_POST['action'])
        }  // if ($_SERVER['REQUEST_METHOD'] == 'POST')
        else
        {
            // la page n'est pas arrivée en POST => en GET
            switch ($_GET['action'])
            {
            case "edit" :
                // avec action=maj
                //  ==> Affichage formulaire de modification
                Afficher_Cadre_Modifier($table, $serveur, $field, $key, $idLigne);
                break;
            case "sup" :
                // avec action=sup
                //  ==> Affichage formulaire de modification
                Afficher_Cadre_Supprimer($table, $serveur, $field, $key, $idLigne);
                break;
            default :
                // sans action ou autre
                //  ==> Affichage de la liste
                echo "<center><a href='"
                      , tabledata_generer_url_ecrire('tabledata',"table")
                      , "'>- Retour à la liste des tables -</a></center>";
                echo $txtMsgInfoTable;
                Afficher_Cadre_Lister($table, $serveur, $field, $key, $boolFntModif,$trisens,$trival);
                if ($boolFntAjout) Afficher_Cadre_Ajouter($table, $serveur, $field, $key);
                echo "<center><a href='"
                      , tabledata_generer_url_ecrire('tabledata',"table")
                      , "'>- Retour à la liste des tables -</a></center>";
                break;
            } // switch ($_GET['action'])
       } // if ($_SERVER['REQUEST_METHOD'] == 'POST')
    } // if (! ($field && $key))


    Tabledata_fin_page();

} // function exec_tabledata_dist()

function Tabledata_fin_page()
{
    echo "\n<br/><br/><hr/>\n"
          ,"<center><i class='arial1' >"
          ,"Plugin TableDATA v0.40 par Christophe Boutin -Opalys.info- <br/>"
          ,"pour la gestion de 'tables extra'."
          ,"</i></center>\n<hr/>\n" ;
    fin_page();
}

/*
TODO1 : supprimer fonction mysql_fetch_row, remplacer par une fonction de abstract (ou qqchose comme ça))
TODO2 : ajouter code pour supprimer ?? (mais si la clef est déjà reprise dans un lien ??...)
*/

/*
==================================================================================
Dernières modifications :
==================================================================================
v0.41 - 01 septembre ------------------------------
- Prise en compte des noms de colonnes "complexes"
- Prise en compte de type supplémentaires (SET, TINYINT(1), ...)
- Correction d'un problème d'affichage des caractères accentués

v0.40 - 19 février --------------------------------
- Ajout mode affichage tables spip ou non (si administrateur)
- Correctif sur edition (suite à modif pour le tri)

v0.33 - 18 février --------------------------------
- Ajout d'une spécification de largeur pour le tableau list (sur le div)
- formulaire d'insertion, passage de DEFAULT à default pour que les
  valeurs par défaut définies dans la tables soient reprises dans le
  formulaire.
- Ajout d'un tri sur les champs, par défaut tri sur clé primaire

v0.32 - 16 février --------------------------------
- Ajout d'un overflow auto sur le tableau de données.
(Pour éviter de tasser les champs)
v0.31 - 16 février --------------------------------
- Suppression de l'erreur affichée si la table est vide.

v0.3 - 12 février --------------------------------
- Mise en place de sécurité et d'une information utilisateur.
   * S'il n'y a pas de clé primaire : La modification n'est pas autorisée.
   * S'il y a plus d'un champ dans la clé primaire :
     La modification et l'ajout ne sont pas autorisées
   * Si il a une clé primaire sans auto-incrément
     La modification est autorisée mais pas l'ajout
   * Si il a une clé primaire avec auto-incrément
     La modification et l'ajout sont autorisées

v0.23 - 12 février --------------------------------
- Correction des requête pour que le script fonctionne
si l'identifiant de la ligne est du texte. (ajout de cotes '' sur la clause WHERE)

v0.22 - 7 fév 2007 --------------------------------
- Correction du chemin des icones.

*/
?>